"use strict";
this.name                   = "GravityWell";
this.author                 = "Stranger";
this.copyright				= "Creative Commons: attribution, non-commercial, sharealike with clauses - see readme.txt";
this.description			= "Script for simulation hyperjump malfunctions in close proximity to planet";
this.version				= "2.3";

this.startUp = this.shipExitedWitchspace = function()
	{
    this.self = player.ship;
    if (system.isInterstellarSpace) return;
	this.$planet = system.mainPlanet;
    this.$altitude = 1000000;
    this.$altBuffer = this.$altitude;
	}

this.shipWillLaunchFromStation = this.$startAltTimer = function()
	{
	this.$altFlag = 0;
	if (this.$altWatchTimer)
		{ this.$altWatchTimer.start(); }
	else
		{ this.$altWatchTimer = new Timer(this, this.$checkAlt,0,1); }
	}

this.shipWillDockWithStation = this.shipDied = this.$stopAltTimer = function()
	{
	this.$altFlag = 0;
	if (this.$altWatchTimer && this.$altWatchTimer.isRunning) { this.$altWatchTimer.stop(); } 
	}
    
this.$checkAlt = function()
	{	
    this.$altFlag += 1;
    this.$altFlag = this.$altFlag % 60;
        if (this.self.status == "STATUS_IN_FLIGHT")
        {
        if (system.isInterstellarSpace) return;        
		this.$altitude = (self.position.distanceTo(this.$planet.position) - this.$planet.radius - self.collisionRadius).toFixed(0);      
        this.$altitude_scaled = this.$altitude / 10;
        if (this.$altitude < this.$planet.radius)
            {
            this.$altitude_ratio = this.$altitude / this.$planet.radius;
            this.self.showHUDSelector("drawAltitudeBar:");
            }
        else
            {
            this.$altitude_ratio = 0;
            this.self.hideHUDSelector("drawAltitudeBar:");
            }
        if (this.$altitude < 25000 && this.$altitude > 4500 && this.$altitude < this.$altBuffer)          //set digital altimeter range
            {
            player.consoleMessage("\n\n\n\n\n\n\n\n\n\n ALT " + this.$altitude_scaled.toFixed(0) + " km",2);
            }
        this.$altBuffer = this.$altitude;
        this.self.setCustomHUDDial("RALT", this.$altitude_ratio);
        }
    }
    
this.playerStartedJumpCountdown = function()
	{
    if (this.$altitude < this.$planet.radius)                              //check if ship is below well horizon
		{
        this.$misjumpFlag = 1;                                           //hyperjump wrong setting
        }
    else
        {
        this.$misjumpFlag = 0;                                           //hyperjump setting OK
        }
    }
    
this.playerCancelledJumpCountdown = function()
	{
    this.$misjumpFlag = 0;                                               //reset hyperjump setting
    }    

this.shipWillEnterWitchspace = function()
	{
    this.$wellHorizon = this.$planet.radius;
    if (this.$altitude < this.wellHorizon)                               //check if ship is below well horizon
		{
        if (this.$misjumpFlag > 0 || this.$altitude < this.$wellHorizon * 0.75)            //hyperjump countdown was started OR finished below safe level
            {
            if (Math.random() > this.$altitude / this.wellHorizon)
                {
                this.self.takeInternalDamage();
                this.self.fuelLeakRate = 1;
                if (Math.random() > this.$altitude / this.wellHorizon)
                    {
                    this.self.scriptedMisjump = true;
                    }
                }
            }
        }

	}

this.shipEnteredPlanetaryVicinity = function(planet)
	{
	this.$planet = planet;
	}