"use strict";
this.name                   = "WarpDrive";
this.author                 = "Stranger";
this.copyright				= "Creative Commons: attribution, non-commercial, sharealike with clauses - see readme.txt";
this.description			= "Script for hypervelocity drive & adjusting ship dynamics";
this.version				= "2.3";

// This script uses FTL drive idea from Norby's Far Planets
// Ship dinamics readjusted - see readme for details

this.startUp = this.playerBoughtNewShip = function()
	{
    this.self = player.ship;
    this.$endurance = this.self.serviceLevel/100;
    this.$wear = 1 - this.$endurance;
    this.$basicMaxSpeed = Math.floor(this.self.maxSpeed * (1 - this.$wear * this.$wear) + 0.5);
    this.$basicMaxThrust = Math.floor(this.self.maxThrust * (1 - 2 * this.$wear * this.$wear) + 0.5);
    this.$basicEnergyRechargeRate = 0.1 * Math.floor(10 * this.self.energyRechargeRate*(1 - 2 * this.$wear * this.$wear) + 0.5);
    this.$basicMaxPitch = this.self.maxPitch;
    this.self.maxSpeed = this.$basicMaxSpeed;
    this.self.maxThrust = this.$basicMaxThrust;
    this.self.energyRechargeRate = this.$basicEnergyRechargeRate;
    this.$lockDistance = 10000000;
    this.$scanRange = 25600;
    this.$scanScale = 1;
	}

this.shipExitedWitchspace = function()
    {
    this.self.maxSpeed = this.$basicMaxSpeed;
    this.self.maxPitch = this.$basicMaxPitch;
    this.self.maxYaw = 0.25 * this.self.maxPitch;
    this.$scanScale = 1;
    }

this.shipWillLaunchFromStation = this.$startWarpTimer = function()
	{
	this.$warpCounter = 0;
    this.$warpFlag = 0;
	if(this.$warpWatchTimer)
		{ this.$warpWatchTimer.start(); }
	else
		{ this.$warpWatchTimer = new Timer(this, this.$checkDistance,0,0.25); }
	}

this.shipWillDockWithStation = this.shipDied = this.$stopWarpTimer = function()
	{
	this.$warpCounter = 0;
	if(this.$warpWatchTimer && this.$warpWatchTimer.isRunning) { this.$warpWatchTimer.stop(); } 
	}
    
this.$checkDistance = function()
	{
    if (system.isInterstellarSpace) return;     // interstellar space check	
    this.$warpCounter += 1;
    this.$warpCounter = this.$warpCounter % 600;
    if (this.self.status == "STATUS_IN_FLIGHT" && this.self.torusEngaged == true)
        {
        this.self.hideHUDSelector("drawForwardShieldBar:");        
        this.self.hideHUDSelector("drawAftShieldBar:"); 
        var aPlanets = system.planets;
        var playerPosition = player.ship.position;
        var playerVector;
        var nplayerVector;
        var distanceToPlanet = 0;
        var ndistanceToPlanet = 9E9;
        var nNumber = 0;
        var nplanetRadius = 0;
	
        if (aPlanets.length == 0)
            {
            return null;
            }
	
        for (var i = 0; i < aPlanets.length; i++)
            {
            playerVector = new Vector3D(playerPosition.subtract(aPlanets[i].position));
            distanceToPlanet = Math.floor(playerVector.magnitude()) - aPlanets[i].radius;
            if (aPlanets[i].radius > 25000 && distanceToPlanet < ndistanceToPlanet)
                {
                nNumber = i;
                nplayerVector = playerVector;
                ndistanceToPlanet = distanceToPlanet;
                this.$lockDistance = 25 * aPlanets[i].radius;
                }
            }
        
        if (ndistanceToPlanet > this.$lockDistance)
            {
            this.$warpFlag = 1;
            }
        else
            {
            this.$warpFlag = 0;
            }

        var sunDistance = this.self.position.distanceTo(system.sun).toFixed(0);
        var warpFactor = sunDistance / (25 * system.sun.radius);
        if (warpFactor < 1)
            {
            this.$warpFlag = 0;
            }

        var e = system.filteredEntities(this, function(e){return(e.isValid && !e.isVisualEffect && (!e.dataKey || e.dataKey != "telescopemarker"));}, this.self, this.$scanScale * this.$scanRange);
        if (e && e[0])
            {
            this.$warpFlag = 0;
            }

        if (this.$warpFlag == 1)
            {
            this.self.maxSpeed = this.$basicMaxSpeed * warpFactor;
            this.self.maxPitch = this.$basicMaxPitch / (32 * warpFactor);
            this.self.maxYaw = 0.25 * this.self.maxPitch;
            this.$scanScale = warpFactor;
            }
        else
            {
            this.self.maxSpeed = this.$basicMaxSpeed;
            this.self.maxPitch = this.$basicMaxPitch / 32;
            this.self.maxYaw = 0.25 * this.self.maxPitch;
            this.$scanScale = warpFactor;
            }
        }
    else
        {
        this.self.showHUDSelector("drawForwardShieldBar:");        
        this.self.showHUDSelector("drawAftShieldBar:");
        if (this.self.fuel > 0)
            {
            this.self.maxSpeed = this.$basicMaxSpeed;
            }
        else
            {
            this.self.maxSpeed = 0.50 * this.$basicMaxSpeed;
            }
        if (this.self.speed > this.self.injectorSpeedFactor * this.$basicMaxSpeed)
            {
            this.self.maxPitch = this.$basicMaxPitch * this.$basicMaxSpeed / this.self.speed;
            }
        else
            {
            this.self.maxPitch = this.$basicMaxPitch;
            }
        this.self.maxYaw = 0.25 * this.self.maxPitch;
        this.$scanScale = 1;
        }
    }